import 'package:flutter/cupertino.dart';
import 'ReponseState.dart';

abstract class CommonProvider<T> extends ChangeNotifier {
  ResponseState<List<T>> objectData;
  @protected
  @mustCallSuper
  void InitData() {
    objectData = ResponseState<List<T>>();
    objectData.ResponseData = List<T>();
  }

  @protected
  @mustCallSuper
  void AddSingleItem(dynamic item) {}

  @protected
  @mustCallSuper
  void AddListItem(dynamic item) {}

  @protected
  @mustCallSuper
  void UpdateSingleItem(dynamic item) {}

  @protected
  @mustCallSuper
  void UpdateListItem(dynamic item) {}

  @protected
  @mustCallSuper
  void DeleteSingleItem(dynamic item) {}

  @protected
  @mustCallSuper
  void DeleteListItem(dynamic item);

  @protected
  @mustCallSuper
  void UpdateState(ResponseState response, {bool append = false}) {
    objectData.State = response.State ?? objectData.State;
    objectData.Exception = response.Exception ?? '';
    if (append) {
      var data = response.ResponseData as List<T>;
      data.length > 0
          ? objectData.ResponseData.addAll(data)
          : objectData.ResponseData;
    } else
      objectData.ResponseData =
          response.ResponseData ?? objectData.ResponseData;
  }
}
